ini=%A_ScriptDir%\mg.ini
ahk=%A_ScriptDir%\mg.ahk
IniRead,timeout,%ini%,General,Timeout,400
IniRead,sensitivity,%ini%,General,Sensitivity,60
sensitivity*=%sensitivity%
IniRead,interval,%ini%,General,Interval,50
IniRead,noicon,%ini%,General,NoIcon,0

IniRead,apporder,%ini%,General,AppOrder
IniRead,gestureorder,%ini%,General,GestureOrder
If gestureorder in ,ERROR
	ExitApp

disbtn=
disbtn=
btnact=
cmdsub=
disable_str=
moveact=

IniRead,disable_c,%ini%,Disable,class
IniRead,disable_t,%ini%,Disable,title
IniRead,disable_e,%ini%,Disable,exe
If disable_c not in ,ERROR
	IfInString,disable_c,`,
		disable_str=%disable_str%If mg_class not in %disable_c%`n
	else
		disable_str=%disable_str%If mg_class<>%disable_c%`n
If disable_t not in ,ERROR
	IfInString,disable_t,`,
		disable_str=%disable_str%If mg_title not contains %disable_t%`n
	else
		disable_str=%disable_str%IfNotInString mg_title`,%disable_t%`n
If disable_e not in ,ERROR
	IfInString,disable_e,`,
		disable_str=%disable_str%If mg_exe not in %disable_e%`n
	else
		disable_str=%disable_str%If mg_exe<>%disable_e%`n

Loop,Parse,apporder,`,
{
	IniRead,appclass,%ini%,App%A_LoopField%,class
	IniRead,apptitle,%ini%,App%A_LoopField%,title
	IniRead,appexe,%ini%,App%A_LoopField%,exe
	rulecount%A_LoopField%=0
	If appclass in ,ERROR
		appclass%A_LoopField%=
	else
	{
		IfInString,appclass,`,
			appclass%A_LoopField%=If mg_class in %appclass%`n
		else
			appclass%A_LoopField%=If mg_class=%appclass%`n
		rulecount%A_LoopField%++
	}
	
	If apptitle in ,ERROR
		apptitle%A_LoopField%=
	else
	{
		IfInString,apptitle,`,
			apptitle%A_LoopField%=If mg_title contains %apptitle%`n
		else
			appclass%A_LoopField%=IfInString,mg_title,%apptitle%`n
		rulecount%A_LoopField%++
	}
	
	If appexe in ,ERROR
		appexe%A_LoopField%=
	else
	{
		IfInString,appexe,`,
			appexe%A_LoopField%=If mg_exe in %appexe%`n
		else
			appexe%A_LoopField%=If mg_exe=%appexe%`n
		rulecount%A_LoopField%++
	}
}

Loop,Parse,gestureorder,`,
{
	actstr=
	gid=%A_LoopField%
	nodefault=1
	Loop,Parse,apporder,`,
	{
		aid=%A_LoopField%
		IniRead,l,%ini%,Gesture%gid%App%aid%,lines
		If l not in 0`,ERROR
		{
			If actstr<>
				actstr=%actstr%else`n
			cmdstr=
			Loop,%l%
			{
				IniRead,s,%ini%,Gesture%gid%App%aid%,%A_Index%
				If s=ERROR
					break
				cmdstr=%cmdstr%%s%`n
			}
			StringTrimLeft,c,appclass%aid%,0
			StringTrimLeft,t,apptitle%aid%,0
			StringTrimLeft,e,appexe%aid%,0
			if l>1
				If rulecount%aid%>1
				{
					cmdsub=%cmdsub%MG_Gesture%gid%App%aid%:`n%cmdstr%return`n
					cmdstr=Gosub,MG_Gesture%gid%App%aid%`n
				}
				else
					cmdstr=%cmdstr%{`n%cmdstr%}`n
			rules=rulecount%aid%
			If c<>
			{
				actstr=%actstr%%c%%cmdstr%
				rules--
				If rules>0
					actstr=%actstr%else`n
			}
			If rules>0
				If t<>
				{
					actstr=%actstr%%t%%cmdstr%
					If rules>1
						actstr=%actstr%else`n%e%%cmdstr%
				}
				else
					actstr=%actstr%%e%%cmdstr%
		}
	}
	IniRead,l,%ini%,Gesture%gid%Default,lines
	If l not in 0`,ERROR
	{
		If actstr<>
			actstr=%actstr%else`n
		cmdstr=
		nodefault=0
		Loop,%l%
		{
			IniRead,s,%ini%,Gesture%gid%Default,%A_Index%
			If s=ERROR
				break
			cmdstr=%cmdstr%%s%`n
		}
		If l>1
			actstr=%actstr%{`n%cmdstr%}`n
		else
			actstr=%actstr%%cmdstr%
	}
	If actstr=
		continue
	IniRead,n,%ini%,Gesture%gid%,Name
	If n in [LButton],[MButton],[WheelUp],[WheelDown],[XButton1],[XButton2]
	{
		StringTrimLeft,n,n,1
		StringTrimRight,n,n,1
		disbtn=%disbtn%Hotkey,%n%,Off`n
		enbtn=%enbtn%Hotkey,%n%,On`n
		btnact=%btnact%%n%`:`:`n%actstr%return`n
	}
	else
	{
		IniRead,g,%ini%,Gesture%gid%,Gestures
		If g in ,ERROR
			continue
		IfInString,g,`,
			moveact=%moveact%If mg_str in %g%`n
		else
			moveact=%moveact%If mg_str=%g%`n
		If nodefault=0
			moveact=%moveact%%actstr%else`n
		else
			moveact=%moveact%{`n%actstr%}`nelse`n
	}
}
FileDelete,%ahk%
If noicon=1
	FileAppend,#NoTrayIcon`n,%ahk%
Loop,Read,%A_ScriptDir%\mg.ahk.txt,%ahk%
	If A_LoopReadLine=`;disable button
		FileAppend,%disbtn%
	else
	If A_LoopReadLine=`;enable button
		FileAppend,%enbtn%
	else
	If A_LoopReadLine=`;button actions
		FileAppend,%btnact%
	else
	If A_LoopReadLine=`;command subroutines
		FileAppend,%cmdsub%
	else
	If A_LoopReadLine=`;Disable applications
		FileAppend,%disable_str%
	else
	If A_LoopReadLine=`;movement actions
		FileAppend,%moveact%
	else
	If A_LoopReadLine=if pow>3600%A_Tab%`;sensitivity
		FileAppend,if pow>%sensitivity%`n
	else
	If A_LoopReadLine=mg_idle+=400%A_Tab%`;timeout
		FileAppend,mg_idle+=%timeout%`n
	else
	If A_LoopReadLine=Sleep,50%A_Tab%`;interval
		FileAppend,Sleep`,%interval%`n
	else
		FileAppend,%A_LoopReadLine%`n
Run,%ahk%
