;-----create window
;main window
Gui,add,Text,,&Application Rule
Gui,add,ListBox,Section vApplicationRule gApplicationSelect r10 AltSubmit
Gui,add,Button,ys x+0 gApplicationUp,&U
Gui,add,Button,y+50 gApplicationDown,&D
Gui,add,Button,xs Section gApplicationAdd,&Add
Gui,add,Button,ys gApplicationEdit,&Edit
Gui,add,Button,ys gApplicationRemove,&Remove

Gui,add,Text,ym,&Gesture
Gui,add,ListBox,Section vGestureRule gGestureSelect r10 AltSubmit
Gui,add,Button,ys x+0 gGestureUp,&U
Gui,add,Button,y+50 gGestureDown,&D
Gui,add,Button,xs Section gGestureAdd,&Add
Gui,add,Button,ys gGestureEdit,&Edit
Gui,add,Button,ys gGestureRemove,&Remove

Gui,add,Text,Section xm,&Command
Gui,add,Edit,ys vCommandString r6 w270
Gui,add,Button,xs ys+20 gCommandSave,&Save

Gui,add,Button,Section x100 gShowOption,&Option
Gui,add,Button,ys x+32 gCreateAHK,&Execute mg.ahk
Gui,add,Button,ys gGuiClose,&Quit


;app rule config window
Gui,2:+Owner1

Gui,2:add,Text,Section,&Name
Gui,2:add,Edit,ys vAppRuleName

Gui,2:add,Edit,Section xm vAppTitleList r6 -wrap
Gui,2:add,Button,gAppTitleAdd,Add &Title
Gui,2:add,Edit,vAppTitle

Gui,2:add,Edit,ys vAppClassList r6
Gui,2:add,Button,gAppClassAdd,Add &Class
Gui,2:add,Edit,vAppClass

Gui,2:add,Edit,ys vAppExeList r6
Gui,2:add,Button,gAppExeAdd,Add &ExeName
Gui,2:add,Edit,vAppExe

Gui,2:add,Button,x300 Section gAppRuleSave,&Save
Gui,2:add,button,ys gCancel,Cancel


;gesture rule config window
Gui,3:+Owner1

Gui,3:add,Text,Section,&Name
Gui,3:add,Edit,ys vGestureRuleName w96

Gui,3:add,Edit,xm vGesturePatternList r6
Gui,3:add,Button,gGesturePatternAdd,&Add Pattern
Gui,3:add,Edit,vGesturePattern

Gui,3:add,Button,x50 Section gGestureRuleSave,&Save
Gui,3:add,button,ys gCancel,Cancel

;optin window
Gui,4:+Owner1
ini=%A_ScriptDir%\mg.ini
IniRead,OptSensitivity,%ini%,General,Sensitivity
sensi2=%OptSensitivity%
sensi2*=%OptSensitivity%
IniRead,OptTimeout,%ini%,General,Timeout
IniRead,OptInterval,%ini%,General,Interval,50
IniRead,OptNoIcon,%ini%,General,NoIcon,0
Gui,4:add,Text,Section,&Sensitivity
Gui,4:add,Edit,Section ys +0x2002 w40 vOptSensitivity,%OptSensitivity%
Gui,4:add,Text,xm ,&Timeout
Gui,4:add,Edit,x100 xs yp+0 +0x2002 w40 vOptTimeout,%OptTimeout%
Gui,4:add,Text,xm ,&Interval
Gui,4:add,Edit,x100 xs yp+0 +0x2002 w40 vOptInterval,%OptInterval%

If OptNoIcon=0
	Gui,4:add,CheckBox,xm w100 vOptNoIcon,#NoTrayIcon
else
	Gui,4:add,CheckBox,xm w100 Checked vOptNoIcon,#NoTrayIcon

Gui,4:add,Button,Default gOptionOK xm w100,&OK
;-----initialize

AppSel=2
GestureSel=1
Gosub,MG_OFF
GoSub,AppRuleListReload
GoSub,GestureRuleListReload
Gui,Show,,MouseGesture Configuration
return



;-----subroutines

;initialize

AppRuleListReload:
	AppListCount=2
	AppList1=Disable
	AppList2=Default
	AppListStr=|[Disable]|[Default]
	IniRead,v,%ini%,General,AppOrder
	If v<>ERROR
		Loop,Parse,v,`,
		{
			IniRead,n,%ini%,App%A_LoopField%,Name,App%A_LoopField%
			AppListCount++
			AppList%AppListCount%=App%A_LoopField%
			AppListStr=%AppListStr%|%n%
		}
	GuiControl,1:,ApplicationRule,%AppListStr%
	GuiControl,1:Choose,ApplicationRule,%AppSel%
return

GestureRuleListReload:
	GestureListCount=0
	GestureListStr=
	IniRead,v,%ini%,General,GestureOrder
	If v<>ERROR
		Loop,Parse,v,`,
		{
			IniRead,n,%ini%,Gesture%A_LoopField%,Name,Gesture%A_LoopField%
			GestureListCount++
			GestureList%A_Index%=%A_LoopField%
			GestureListStr=%GestureListStr%|%n%
		}
	GuiControl,1:,GestureRule,%GestureListStr%
	GuiControl,1:Choose,GestureRule,%GestureSel%
return


CommandReload:
	GuiControlGet,ApplicationRule
	GuiControlGet,GestureRule
	StringTrimLeft,aid,AppList%ApplicationRule%,0
	StringTrimLeft,gid,GestureList%GestureRule%,0
	cmdsec=Gesture%gid%%aid%
	IniRead,l,%ini%,%cmdsec%,lines,1
	cmdstr=
	Loop,%l%
	{
		IniRead,s,%ini%,%cmdsec%,%A_Index%
		If s=ERROR
			break
		cmdstr=%cmdstr%%s%`n
	}
	GuiControl,,CommandString,%cmdstr%
return


;app rule list

ApplicationSelect:
	If A_GuiControlEvent=DoubleClick
		Gosub,ApplicationEdit
	else
		Gosub,CommandReload
return

ApplicationUp:
	GuiControlGet,ApplicationRule
	If ApplicationRule in 0,1,2,3,-1
		return
	to=%ApplicationRule%
	to--
	Gosub,ApplicationMove
return

ApplicationDown:
	GuiControlGet,ApplicationRule
	If ApplicationRule in %AppListCount%,0,1,2,-1
		return
	to=%ApplicationRule%
	to++
	Gosub,ApplicationMove
return

ApplicationMove:
	str=
	StringTrimLeft,x,AppList%to%,0
	StringTrimLeft,y,AppList%ApplicationRule%,0
	AppList%to%=%y%
	AppList%ApplicationRule%=%x%
	Loop,%AppListCount%
	{
		If A_Index<3
			continue
		StringTrimLeft,this,AppList%A_Index%,3
		str=%str%`,%this%
	}
	StringTrimLeft,str,str,1
	IniWrite,%str%,%ini%,General,AppOrder
	AppSel=%to%
	GoSub,AppRuleListReload
return

ApplicationAdd:
	EditingApp=New
	Gui,2:Show,,NewApp
return

ApplicationEdit:
	GuiControlGet,ApplicationRule
	If ApplicationRule=2
		return
	StringTrimLeft,sel,AppList%ApplicationRule%,0
	EditingApp=%sel%
	IniRead,n,%ini%,%sel%,Name,%sel%
	IniRead,c,%ini%,%sel%,class
	IniRead,t,%ini%,%sel%,title
	IniRead,e,%ini%,%sel%,exe
	GuiControl,2:,AppRuleName,%n%
	If c<>ERROR
		StringReplace,c,c,`,,`n,All
	else
		c=
	GuiControl,2:,AppClassList,%c%
	If t<>ERROR
		StringReplace,t,t,`,,`n,All
	else
		t=
	GuiControl,2:,AppTitleList,%t%
	If e<>ERROR
		StringReplace,e,e,`,,`n,All
	else
		e=
	GuiControl,2:,AppExeList,%e%
	Gui,2:Show,,%sel%: %n%
return

ApplicationRemove:
	GuiControlGet,ApplicationRule
	If ApplicationRule<3
		return
	MsgBox,1,Remove Application Rule,OK?
	IfMsgBox,Cancel
		return
	AppSel=%ApplicationRule%
	If ApplicationRule=%AppListCount%
		AppSel--
	str=
	Loop,%AppListCount%
	{
		If A_Index<3
			continue
		StringTrimLeft,this,AppList%A_Index%,3
		If A_Index=%ApplicationRule%
			IniDelete,%ini%,App%this%
		else
			str=%str%`,%this%
	}
	StringTrimLeft,str,str,1
	IniWrite,%str%,%ini%,General,AppOrder
	GoSub,AppRuleListReload
return


;gesture rule list

GestureSelect:
	If A_GuiControlEvent=DoubleClick
		Gosub,GestureEdit
	else
		Gosub,CommandReload
return

GestureUp:
	GuiControlGet,GestureRule
	If GestureRule in 1,0,-1
		return
	to=%GestureRule%
	to--
	Gosub,GestureMove
return

GestureDown:
	GuiControlGet,GestureRule
	If GestureRule in %GestureListCount%,0,-1
		return
	to=%GestureRule%
	to++
	Gosub,GestureMove
return

GestureMove:
	str=
	StringTrimLeft,x,GestureList%to%,0
	StringTrimLeft,y,GestureList%GestureRule%,0
	GestureList%to%=%y%
	GestureList%GestureRule%=%x%
	Loop,%GestureListCount%
	{
		StringTrimLeft,this,GestureList%A_Index%,0
		str=%str%`,%this%
	}
	StringTrimLeft,str,str,1
	IniWrite,%str%,%ini%,General,GestureOrder
	GestureSel=%to%
	GoSub,GestureRuleListReload
return

GestureAdd:
	EditingGesture=New
	GuiControl,3:,GesturePatternList,
	Gui,3:Show,,NewGesture
return

GestureEdit:
	GuiControlGet,GestureRule
	StringTrimLeft,sel,GestureList%GestureRule%,0
	EditingGesture=%sel%
	IniRead,n,%ini%,Gesture%sel%,Name,Gesture%sel%
	If n in [LButton],[MButton],[WheelUp],[WheelDown],[XButton1],[XButton2]
		return
	IniRead,g,%ini%,Gesture%sel%,Gestures
	GuiControl,3:,GestureRuleName,%n%
	If g<>ERROR
		StringReplace,g,g,`,,`n,All
	else
		g=
	GuiControl,3:,GesturePatternList,%g%
	Gui,3:Show,,Gesture%sel%: %n%
return

GestureRemove:
	MsgBox,1,Remove Application Rule,OK?
	IfMsgBox,Cancel
		return
	GuiControlGet,GestureRule
	GestureSel=%GestureRule%
	If GestureRule=%GestureListCount%
		GestureSel--
	str=
	Loop,%GestureListCount%
	{
		StringTrimLeft,this,GestureList%A_Index%,0
		If A_Index=%GestureRule%
			IniDelete,%ini%,Gesture%this%
		else
			str=%str%`,%this%
	}
	StringTrimLeft,str,str,1
	IniWrite,%str%,%ini%,General,GestureOrder
	GoSub,GestureRuleListReload
return


;command edit

CommandSave:
	If cmdsec=
		return
	If aid=Disable
		return
	GuiControlGet,CommandString
	l=0
	IniDelete,%ini%,%cmdsec%
	Loop,Parse,CommandString,`n
	{
		IniWrite,%A_LoopField%,%ini%,%cmdsec%,%A_Index%
		If A_LoopField<>
			l=%A_Index%
	}
	IniWrite,%l%,%ini%,%cmdsec%,lines
return



;window2

AppTitleAdd:
	GuiControlGet,AppTitleList,2:
	GuiControlGet,AppTitle,2:
	If AppTitleList<>
		AppTitleList=%AppTitleList%`n
	GuiControl,2:,AppTitleList,%AppTitleList%%AppTitle%
return

AppClassAdd:
	GuiControlGet,AppClassList,2:
	GuiControlGet,AppClass,2:
	If AppClassList<>
		AppClassList=%AppClassList%`n
	GuiControl,2:,AppClassList,%AppClassList%%AppClass%
return

AppExeAdd:
	GuiControlGet,AppExeList,2:
	GuiControlGet,AppExe,2:
	If AppExeList<>
		AppExeList=%AppExeList%`n
	GuiControl,2:,AppExeList,%AppExeList%%AppExe%
return

AppRuleSave:
	Gui,2:Submit
	If EditingApp=New
	{
		IniRead,list,%ini%,General,AppOrder
		Loop
			If A_Index not in %list%,1,2
			{
				IniWrite,%list%`,%A_Index%,%ini%,General,AppOrder
				EditingApp=App%A_Index%
				break
			}
		AppSel=%AppListCount%
		AppSel++
	}
	StringReplace,AppClassList,AppClassList,`n,`,,All
	StringReplace,AppTitleList,AppTitleList,`n,`,,All
	StringReplace,AppExeList,AppExeList,`n,`,,All
	IniWrite,%AppRuleName%,%ini%,%EditingApp%,name
	IniWrite,%AppClassList%,%ini%,%EditingApp%,class
	IniWrite,%AppTitleList%,%ini%,%EditingApp%,title
	IniWrite,%AppExeList%,%ini%,%EditingApp%,exe
	Gosub,AppRuleListReload
return



;window3
GesturePatternAdd:
	GuiControlGet,GesturePatternList,3:
	GuiControlGet,GesturePattern,3:
	If GesturePatternList<>
		GesturePatternList=%GesturePatternList%`n
	GuiControl,3:,GesturePatternList,%GesturePatternList%%GesturePattern%
return

GestureRuleSave:
	Gui,3:Submit
	If EditingGesture=New
	{
		IniRead,list,%ini%,General,GestureOrder
		If GestureRuleName in [LButton],[MButton],[WheelUp],[WheelDown],[XButton1],[XButton2]
			Loop,Parse,list,`,
			{
				IniRead,n,%ini%,Gesture%A_LoopField%,Name
				If n=%GestureRuleName%
					return
			}
		Loop
			If A_Index not in %list%
			{
				IniWrite,%list%`,%A_Index%,%ini%,General,GestureOrder
				EditingGesture=%A_Index%
				break
			}
		GestureSel=%GestureListCount%
		GestureSel++
	}
	StringReplace,GesturePatternList,GesturePatternList,`n,`,,All
	IniWrite,%GestureRuleName%,%ini%,Gesture%EditingGesture%,name
	IniWrite,%GesturePatternList%,%ini%,Gesture%EditingGesture%,Gestures
	Gosub,GestureRuleListReload
return

;Option
ShowOption:
	IniRead,OptSensitivity,%ini%,General,Sensitivity,60
	IniRead,OptTimeout,%ini%,General,Timeout,400
	IniRead,OptInterval,%ini%,General,Interval,50
	IniRead,OptNoIcon,%ini%,General,NoIcon,0
	GuiControl,4:,OptSensitivity,%OptSensitivity%
	GuiControl,4:,OptTimeout,%OptTimeout%
	GuiControl,4:,OptInterval,%OptInterval%
	GuiControl,4:,OptNoIcon,%OptNoIcon%
	Gui,4:Show,,Other Options
return

OptionOK:
	Gui,4:Submit
	IniWrite,%OptSensitivity%,%ini%,General,Sensitivity
	IniWrite,%OptTimeout%,%ini%,General,Timeout
	IniWrite,%OptInterval%,%ini%,General,Interval
	IniWrite,%OptNoIcon%,%ini%,General,NoIcon
sensi2=%OptSensitivity%
sensi2*=%OptSensitivity%
return

;exit
CreateAHK:
	Run,%A_ScriptDir%\mgini2ahk.ahk

GuiClose:
	ExitApp




SetWindowInfo:
	AppSel=2
	Loop,%AppListCount%
	{
		StringTrimLeft,this,AppList%A_Index%,0
		IniRead,n,%ini%,%this%,Name,%this%
		IniRead,c,%ini%,%this%,class
		IniRead,t,%ini%,%this%,title
		IniRead,e,%ini%,%this%,exe
		If mg_wclass not in %c%
			If mg_wtitle not contains %t%
				If mg_wclass not in %c%
					continue
		AppSel=%A_Index%
		break
	}
	Gosub,AppRuleListReload
	Gosub,CommandReload
	StringReplace,en,mg_wexename,.exe,
	GuiControl,2:,AppRuleName,%en%
	GuiControl,2:,AppClass,%mg_wclass%
	GuiControl,2:,AppTitle,%mg_wtitle%
	GuiControl,2:,AppExe,%mg_wexename%
return


MG_OFF:
	Hotkey,LButton,Off
	Hotkey,MButton,Off
	Hotkey,XButton1,Off
	Hotkey,XButton2,Off
	Hotkey,WheelUp,Off
	Hotkey,WheelDown,Off
return

MG_ON:
	Hotkey,LButton,On
	Hotkey,MButton,On
	Hotkey,XButton1,On
	Hotkey,XButton2,On
	Hotkey,WheelUp,On
	Hotkey,WheelDown,On
return

LButton::
MButton::
WheelUp::
WheelDown::
XButton1::
XButton2::
	Loop,%GestureListCount%
	{
		StringTrimLeft,this,GestureList%A_Index%,0
		IniRead,str,%ini%,Gesture%this%,Name
		If str=[%A_ThisHotkey%]
		{
			GestureSel=%A_Index%
			Gosub,GestureRuleListReload
			Gosub,CommandReload
			break
		}
	}
	GuiControl,3:,GestureRuleName,[%A_ThisHotkey%]
	GuiControl,3:,GesturePattern,
	Gosub,SetWindowInfo
return

RButton::
CoordMode,Mouse,Screen
MouseGetPos,px,py,mg_whandle
WinWait,ahk_id %mg_whandle%
WinGet,mg_wexename,ProcessName
WinGetClass,mg_wclass
WinGetTitle,mg_wtitle
Gosub,MG_ON
SetMouseDelay,-1
SetDefaultMouseSpeed,0
mg_rheld=0
mg_str=
mg_dir1=
mg_idle=%A_TickCount%
mg_idle+=%OptTimeout%
px2=%px%
py2=%py%
loop
{
	GetKeyState,st,RButton,P
	if st=U
	{
		if mg_rheld=0
		{
			GoSub,MG_OFF
			If mg_str<>
			{
				Loop,%GestureListCount%
				{
					StringTrimLeft,this,GestureList%A_Index%,0
					IniRead,str,%ini%,Gesture%this%,Gestures,
					If mg_str in %str%
					{
						GestureSel=%A_Index%
						Gosub,GestureRuleListReload
						Gosub,CommandReload
						break
					}
				}
				GuiControl,3:,GestureRuleName,%mg_str%
				GuiControl,3:,GesturePattern,%mg_str%
				Gosub,SetWindowInfo
			}
		}
		else
			MouseClick,R,,,,,U
		return
	}
	else
	if mg_idle>%A_TickCount%
	{
		MouseGetPos,dx,dy
		dx-=%px2%
		dy-=%py2%
		powx=%dx%
		powx*=%dx%
		powy=%dy%
		powy*=%dy%
		pow=%powx%
		pow+=%powy%
if pow>%sensi2%
		{
			if powx>%powy%
				if dx>0
					mg_dir2=R
				else
					mg_dir2=L
			else
				if dy>0
					mg_dir2=D
				else
					mg_dir2=U
			if mg_dir2<>%mg_dir1%
			{
				mg_str=%mg_str%%mg_dir2%
				mg_dir1=%mg_dir2%
			}
			MouseGetPos,px2,py2
			mg_idle=%A_TickCount%
mg_idle+=%OptTimeout%
		}
	}
	else
	if mg_rheld=0
	if A_ThisHotkey=RButton
	{
		MouseGetPos,px2,py2
		if px2<>%px%
		if py2<>%py%
		{
			MouseClick,R,%px%,%py%,,,D
			MouseMove,%px2%,%py2%
			mg_rheld=1
			GoSub,MG_OFF
		}
	}
}

